unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, ExtCtrls, ExtDlgs, Grids, StdCtrls, SysUtils, FileUtil, Forms,
  Controls, Graphics, Dialogs, thumbcontrol, threadedimageLoader;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    Panel1: TPanel;
    Splitter1: TSplitter;
    StringGrid1: TStringGrid;
    ThumbControl1: TThumbControl;
    procedure Button1Click(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; aCol, aRow: Integer;
      var CanSelect: Boolean);
    procedure ThumbControl1SelectItem(Sender: TObject; Item: TThreadedImage);
  private
    { private declarations }
    procedure UpdateSelectedImage;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  i: Integer;
begin
  with OpenPictureDialog1 do begin
    if Execute then begin
       Thumbcontrol1.URLList := Thumbcontrol1.URLList + Files.Text;
       Thumbcontrol1.Invalidate;
       StringGrid1.RowCount := StringGrid1.FixedRows + ThumbControl1.ImageLoaderManager.CountItems;
       for i:=0 to ThumbControl1.ImageLoaderManager.CountItems-1 do
         StringGrid1.Cells[0, i + StringGrid1.FixedRows] := ExtractFileNameOnly(ThumbControl1.ImageLoaderManager.ItemFromIndex(i).URL);
    end;
  end;
end;

procedure TForm1.StringGrid1SelectCell(Sender: TObject; aCol, aRow: Integer;
  var CanSelect: Boolean);
var
  idx: Integer;
begin
  idx := ARow - StringGrid1.FixedRows;
  if idx < 0 then
    exit;
  with ThumbControl1 do begin
    ImageLoaderManager.ActiveIndex := idx;
    ScrollIntoView;
  end;
  UpdateSelectedImage;
end;

procedure TForm1.ThumbControl1SelectItem(Sender: TObject; Item: TThreadedImage);
var
  idx: Integer;
begin
  UpdateSelectedImage;
  idx := ThumbControl1.ImageLoaderManager.ActiveIndex + StringGrid1.FixedRows;
  StringGrid1.Row := idx;
end;

procedure TForm1.UpdateSelectedImage;
var
  idx: Integer;
  img: TThreadedImage;
begin
  ThumbControl1.LoadSelectedBitmap(Image1.Picture.Bitmap);
  idx := ThumbControl1.ImageLoaderManager.ActiveIndex;
  if idx > -1 then begin
    img := ThumbControl1.ImageLoaderManager.ItemFromIndex(idx);
    if img <> nil then begin
      Form1.Caption := 'Form1 - ' + ExtractFileName(img.URL);
      exit;
    end;
  end;
  Form1.Caption := 'Form1';
end;

end.

